/***********************************************************
 * $Id$
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYTHROWABLEEXCEPTION_H_
#define FANCYTHROWABLEEXCEPTION_H_

#include <fancyexception.h>
#include <fancyobject.h>

namespace Fancy {

class Throwable;

/**
 * This class acts as a bridge between Java Throwable instances and
 * C++ exceptions.
 */
class FANCYBASE_API ThrowableException: public Fancy::Exception {
public:
    ThrowableException(int facility,
                       int priority,
                       const ObjPtr<Throwable> &throwable) throw();

    virtual ~ThrowableException() throw();

    ObjPtr<Throwable> getThrowable() const;

    ThrowableException (fancylog_service *service,
                        int facility,
                        int priority,
                        const ObjPtr<Throwable> &throwable) throw();

private:

    void initMessage();
    ObjPtr<Throwable> throwable;
};

}

#endif /* FANCYTHROWABLEEXCEPTION_H_ */
